package cn.iocoder.yudao.module.order.param;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@Data
@ApiModel(value = "处理渠道异常自定义价格参数")
public class OrderChangePriceParam {

    @ApiModelProperty("订单项id")
    private Long orderItemId;

    @ApiModelProperty("运费")
    private BigDecimal freightFee;

    @ApiModelProperty("运费货币")
    private Integer freightCurrencyId;

    @ApiModelProperty("运费计量单位id")
    private Long freightUnitId;

    @ApiModelProperty("清关费")
    private BigDecimal clearanceFee;

    @ApiModelProperty("清关费货币")
    private Integer clearanceCurrencyId;

    @ApiModelProperty("清关费计量单位id")
    private Long clearanceUnitId;

    @ApiModelProperty(value = "是否预付：0 到付 1 预付")
    private Integer isPayAdvance = 0;

    @ApiModelProperty(value = "计费方式：0 运费/清关费 1 全包价")
    private Integer charging = 0;
}
