package cn.iocoder.yudao.module.order.vo.orderWarehouseApproval;

import lombok.*;
import java.util.*;
import io.swagger.annotations.*;
import com.alibaba.excel.annotation.ExcelProperty;
import cn.iocoder.yudao.framework.excel.annotations.DictFormat;
import cn.iocoder.yudao.framework.excel.convert.DictConvert;
import org.springframework.format.annotation.DateTimeFormat;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

/**
* 入仓单审核 Response VO
* @author yanghao
*/
@Data
@ApiModel("管理后台 - 入仓单审核 Response VO")
public class OrderWarehouseApprovalBackVO {

    @ExcelProperty("主键ID")
    @ApiModelProperty(value = "主键ID", required = true)
    private Long id;

    @ExcelProperty("订单ID")
    @ApiModelProperty(value = "订单ID", required = true)
    private String orderIds;

    @ExcelProperty("订单编号")
    @ApiModelProperty(value = "订单编号", required = true)
    private String orderNo;

    @ExcelProperty("订单项id")
    @ApiModelProperty(value = "订单项id", required = true)
    private Long orderItemId;

    @ExcelProperty("入仓id")
    @ApiModelProperty(value = "入仓id")
    private Long warehouseInId;

    @ExcelProperty("流程表单实例ID")
    @ApiModelProperty(value = "流程表单实例ID")
    private String formId;

    @ExcelProperty(value = "类型：1 入仓修改 2 调仓 3 退仓 见字典order_warehouse_approval_type", converter = DictConvert.class)
    @DictFormat("order_warehouse_approval_type") // TODO 代码优化：建议设置到对应的 XXXDictTypeConstants 枚举类中
    @ApiModelProperty(value = "类型：1 入仓修改 2 调仓 3 退仓 见字典order_warehouse_approval_type")
    private Integer type;

    @ExcelProperty("跟进业务员")
    @ApiModelProperty(value = "跟进业务员")
    private Long followUpAdminId;

    @ExcelProperty("审核内容/修改前")
    @ApiModelProperty(value = "审核内容/修改前")
    private String details;

    @ExcelProperty("状态：1 处理中 2 通过 3 不通过 4 取消")
    @ApiModelProperty(value = "状态：1 处理中 2 通过 3 不通过 4 取消")
    private Integer status;

    @ExcelProperty("处理结果")
    @ApiModelProperty(value = "处理结果")
    private String processingResults;

    @ExcelProperty("结束人")
    @ApiModelProperty(value = "结束人")
    private String finishBy;

    @ExcelProperty("结束时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束时间")
    private Date finishTime;

    @ExcelProperty("创建时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "创建时间", required = true)
    private Date createTime;

    /**
     * 是否批量
     */
    @ExcelProperty("是否批量提交")
    @ApiModelProperty(value = "是否批量提交")
    private Boolean isBatch;


    @ApiModelProperty(value = "调仓实际的订单id", required = true)
    private String adjustActualOrderIds;


    /**
     * 是否来自于用户客户端
     */
    @ExcelProperty("是否来自用户客户端")
    @ApiModelProperty(value = "是否来自于用户客户端")
    private Boolean isFromUserClient = false;

    @ApiModelProperty(value = "退仓图片url")
    private String imgUrl;

}
